\section{Introduction}

\subsection{Summary}

This project was part of the Software Engineering Laboratory CES (this course is organized by the STCE - "Informatik 12: Software and Tools for Computational Engineering"), where our group was given the task of designing a Graphical User Interface (GUI) for the software tool DyOS. DyOS is used to solve dynamic optimization problems and developed at the "Chair of Process Systems Engineering" (AVT.SVT, RWTH Aachen).

\subsection{Project Management}

The project was mostly developed in joined meetings of our team members, but also independently at home. Using editing environments like "Visual Studio Code" with the "Live Share" extension, or "Overleaf", proved useful for working on the source code and the latex documentation simultaneously.

Different aspects of the GUI were assigned to different group members, to split the work among us, and we were able to work very independent from each other. For this reason, different parts of the code and this document may use a slightly different style, but we tried to keep it as consistent as possible. Most communication with our group's supervisor was handled by just one member of the group, in order to have just "one face" representing the project, which avoids confusion and is a good idea in general for something like this. Still, whenever we met with our supervisor at the AVT.STV, the entire group was present so that everyone would receive new information first hand.

Additionally, the entire progress of the project was put under Git version control early on in the development process, since our group developed the GUI entirely inside the main DyOS GitLab repository and alongside DyOS code after we got access to it.

\subsection{Timeline}

\subsubsection{Phase 1}

The formal beginning of our project was the first meeting at the AVT.SVT on the 21.06.2019.

In the first phase of the project our group established the design of the GUI together with the AVT.SVT in a series of meetings. These first meetings also had to be used to explain the compilation process of DyOS to us, as well as some of the basics on how to use DyOS correctly. Our group also created a first GUI design on paper (which can be seen in section \ref{sec:Prototype}), to establish a common vision together with the AVT.SVT. These drawings were only very rudimentary, but helped to convey our design direction and ideas to our client. The AVT.SVT also provided useful feedback about our first design pitch to us.

We collected a lot of ideas about the GUI's structure and code design, and also considered a couple of software design paradigms. Our idea was to use a lot of the existing routines and data structures of DyOS, and to avoid a duplication of existing structures at all costs. More about our design decisions and key principles can be read in section \ref{sec:Design}. In addition to that we also acquainted ourselves with the Qt framework, which already contains a wide variety of useful objects and routines. 

Leading up to our first presentation about the project, we also created a first mock-up of the GUI in Qt Creator. This mock-up was not fully functional, because it was not possible to actually run DyOS with it, but visually it came closer to the final product than our preliminary drawings. We also met up with the AVT.SVT again and showed them our mock-up, which was received very well. Just like during our previous meetings, we got valuable feedback on our prototype, which allowed us to tweak it further. We were able to show the mock-up in a live demonstration during our presentation on the 11.07.2019, which concluded the first phase of development.

\subsubsection{Phase 2}\label{sec:Phase2}

The second phase of the project encompassed the actual implementation of the GUI, and it started roughly on the 02.09.2019. After some of the groundwork had been laid down, e.g. after all three tabs received their own classes, the code was "spread out" enough so that we were able to divide the work among the group members.

For the most part during the implementation phase we did not require any further meetings at the AVT.SVT, since most of our questions were brief enough to ask them via GitLab issues or using emails. However, particularly at the start, we still had a lot of questions regarding the usage of DyOS, which we collected and asked our supervisor in a phone call. 

Leading up to the second and final presentation, we tried to wrap up most of the issues which had accumulated, and also met with our supervisor again to ensure that the GUI was still meeting his expectations, and that he no longer had any wishes which me may still be able to fulfill. On the day before our final presentation we were also able to perform a "test run" of the presentation in front of our supervisor, which was very helpful to practise the presentation and to receive some last feedback on our slides.

The final presentation took place on the 31.10.2019, at which point the GUI was essentially feature-complete. The submission deadline for this very document lies on the 30.11.2019, and in the time leading up to this deadline, we mostly added to the Doxygen documentation and to this document. Smaller style changes, which only became obvious while writing the documentation, where still performed in the code during this time. 

After this document has been submitted for evaluation, together with our code, there will still be one final meeting at the AVT.SVT, during which we will merge our fork of DyOS back into the main repository. After this "handover meeting", the project will be completed.


\subsection{Useful Tools}\label{sec:UsefulTools}

\begin{itemize}
    \item \textbf{Visual Studio Code:} All four of us used this IDE, since it suited our purposes really well. It is fairly lightweight, it offers some great IntelliSense functionality for C++, and especially the "Git Graph" extension proved itself to be very helpful, because it gave us a good way to visualize the different commits and branches, but also to perform most of the Git commands using a GUI. The program also offers a very useful debugger, which we used to find some bugs in the software. The "Live Share" extension was also very helpful whenever we wanted to collaborate on the code in real time. And one last very handy extension was the "Doxygen Documentation Generator", which helps a lot with the syntax of Doxygen function headers and such. 
    
    \item \textbf{Qt Creator:} This program pretty much \textit{has to} be used to edit {\tt .ui} files, so we used it to design most of the actual appearance of the GUI, but also to set some of the properties of UI elements, e.g. the available options in a static "ComboBox". At the start of the project we still used Qt Creator to also compile our program and make smaller changes to the code, as Qt Creator is even able to open "CMakeLists.txt" files as project files. However, towards the end we used {\tt make} (MacOS) and Visual Studio (Windows) pretty much exclusively to build the project. 
    
    \item \textbf{GitLab:} We were able to use the RWTH's GitLab instance to host our fork of the AVT.SVT's main DyOS repository, which was very helpful for organizing our code. Not only did GitLab offer all the features you expect from a Git remote, but it also let us create issues to keep track of bugs and other features which should be implemented. Fortunately the AVT.SVT also used GitLab, which meant that we were able to create issues with our questions about DyOS, and assign these issues to our supervisor, who could answer the questions.

    \item \textbf{Overleaf:} This was a very useful online editor for the very LaTex document you are ready right now, because it offered real time collaboration on and compilation of the documentation.

\end{itemize}